<template>
  <div class="grid">
      <ul v-if="viewModes.length > 1" class="grid__model nav nav-tabs mb-3">
        <li class="nav-item">
          <a
            class="nav-link"
            :class="{
              'active': tableViewModeActive
            }"
            href=""
            v-if="isViewModeEnabled(viewModesEnum.table)"
            @click.prevent="activeViewMode = viewModesEnum.table"
          >Tabulka</a>
        </li>
        <li class="nav-item">
          <a
            class="nav-link"
            :class="{
              'active': galleryViewModeActive
            }"
            href=""
            v-if="isViewModeEnabled(viewModesEnum.gallery)"
            @click.prevent="activeViewMode = viewModesEnum.gallery"
          >Gallery</a>
        </li>
      </ul>
      <GalleryViewMode
        :data="data"
        v-if="galleryViewModeActive"
      /> 
      <TableViewMode
        v-if="tableViewModeActive"
        :columns="columns"
        :data="data"
        :isStriped="stripedTable"
      />
  </div> 
</template>

<script lang="ts">
import {Vue, Component, Prop, Watch} from 'vue-property-decorator'
import {Column, Row, ViewModes} from './types'
import GalleryViewMode from './viewMode/GalleryViewMode.vue'
import TableViewMode from './viewMode/TableViewMode.vue'

@Component({
  // props: {
  //   columns: {
  //     type: Array as PropType<Column[]>,
  //     default: () => []
  //   },
  // },
  components: {
    GalleryViewMode,
    TableViewMode
  }
})
export default class Grid extends Vue {
  @Prop({default: () => []})
  columns!: Column[]

  @Prop({default: () => []})
  data!: Row[]

  @Prop({ default: () => [ViewModes.table] })
  viewModes!: string[]

  @Prop({default: false})
  stripedTable!: boolean

  @Watch('viewModes', { immediate: true })
  updateActiveViewMode() {
    if(this.viewModes.length > 0) {
      this.activeViewMode = this.viewModes[0]
    }
  }
  
  activeViewMode: string | null = null
  
  get viewModesEnum() {
    return ViewModes
  }

  get tableViewModeActive(): boolean {
    return this.activeViewMode === ViewModes.table
  }

  get galleryViewModeActive(): boolean {
    return this.activeViewMode === ViewModes.gallery
  }

  isViewModeEnabled(viewMode: string): boolean {
    return this.viewModes.includes(viewMode)
  }
}
</script>
